/*
 * 3D Engine 
 * colour.h: 
 * Based on pikuma.com 3D software renderer in C
 * Copyright (c) 2021 986-Studio. All rights reserved.
 *
 * Created by Manoël Trapier on 15/03/2021.
 */

#ifndef THREEDENGINE_SOURCE_INCLUDE_COLOUR_H
#define THREEDENGINE_SOURCE_INCLUDE_COLOUR_H

/***********************************************************************************************************************
 * Data types
 **********************************************************************************************************************/
typedef uint32_t colour_t;

/***********************************************************************************************************************
 * Prototypes
 **********************************************************************************************************************/
#define MAKE_RGB(_r, _g, _b) ((0xFF000000) | ((_b & 0xFF) << 16) | ((_g & 0xFF) << 8) | ((_r & 0xFF)))
#define MAKE_ARGB(_a, _r, _g, _b) (((_a & 0xFF) << 24) | ((_g & 0xFF) << 16) | ((_g & 0xFF) << 8) | ((_r & 0xFF)))

#endif /* THREEDENGINE_SOURCE_INCLUDE_COLOUR_H */
